/*
 * ApproximateMathing.java
 *
 * Created on February 8, 2005, 12:50 PM
 */

/**
 *
 *          Naushad UzZaman 
 *          Intern: Center for Research on Bangla Language Processing
 *          Senior Student, CSE Dept.
 *          BRAC University
 *          email: naushad@bracuniversity.net
 *                 naushadzaman@gmail.com
 */


package Speller;

import java.util.*;

public class ApproximateMathing {
    
    String word;
    String encodeWord;
    TreeMap m;
    TreeMap tm;
    PhoneticEncoding pe;
    /** Creates a new instance of ApproximateMathing */
    public ApproximateMathing(TreeMap mCa) {
        pe = new PhoneticEncoding(); 
        m = mCa;
        tm = new TreeMap();
    }
    
    public void processSugesstion(String wrd, String ncdWrd){
        word = wrd;
        encodeWord = ncdWrd;
        
        Set Cset = m.entrySet();
	Iterator iC = Cset.iterator();
        tm.clear(); 
        while (iC.hasNext()) {
            Map.Entry me = (Map.Entry) iC.next();
            Object element = me.getValue();
            Object elK = me.getKey();
            String curLexWord = (String)elK;
            String curLexCode = (String)element;
            String wrdCd = pe.encoding(word);
            double edWord;
         //   System.out.println(curLexCode+":Lex|"+wrdCd+":Test");
            //System.out.println("For word"+curLexCode+"with length"+curLexCode.length()+"and"+wrdCd+"with length"+wrdCd.length());
            double edCode = EditDistance(curLexCode, wrdCd);
            double score;
            
            //score = total score
            //edCode = editDistance code
            //erWord = editDistance word
            //if edCode is closer then get the score and do accordingly
           // System.out.println("Word:"+curLexCode+"|with score:"+score+"|edWord:"+edWord+"|edCode"+edCode);
            if(edCode >=0.75){
                edWord = EditDistance(curLexWord, word);
                score = edCode + edWord/100.0;
                while (tm.containsKey(new Double(1.0-score)) == true) {
                        score -= 0.001;
                }
                tm.put(new Double(1.0-score), curLexWord);
		//System.out.println("Accepted: Word:"+PhoneticEncoding.encoding(curLexWord)+"|with score"+score+"|edWord:"+edWord+"|edCode"+edCode);
                
            }            
        }	
    }
    
    public TreeMap getSuggestion(){
        
        return tm;
    }

    
    private int Minimum(int a, int b, int c) {
	int mi;

	mi = a;
	if (b < mi) {
            mi = b;
	}

	if (c < mi) {
            mi = c;
	}

	return mi;

    }

    public double EditDistance(String ST, String t){
        int d[][]; // matrix
	int n; // length of s
	int m; // length of t
	int i; // iterates through s
	int j; // iterates through t
	char s_i; // ith character of s
	char t_j; // jth character of t
	int cost; // cost
        int max; 
        double ED;
	// Step 1
        
	n = ST.length();
	m = t.length();
        //System.out.println("for "+ST+"length:"+n);
        //System.out.println("for "+t+"length:"+m);
	if (n == 0) {
            return m;
	}

	if (m == 0) {
            return n;
        }

    	d = new int[n + 1][m + 1];

	// Step 2

	for (i = 0; i <= n; i++) {
            d[i][0] = i;
        }

	for (j = 0; j <= m; j++) {
            d[0][j] = j;
	}

	// Step 3

	for (i = 1; i <= n; i++) {

            s_i = ST.charAt(i - 1);

            // Step 4

                for (j = 1; j <= m; j++) {

                    t_j = t.charAt(j - 1);

			// Step 5

                        if (s_i == t_j) {
                            cost = 0;
			} else {
                            cost = 1;
			}

			// Step 6

                    d[i][j] =   Minimum(
                                	d[i - 1][j] + 1,
					d[i][j - 1] + 1,
					d[i - 1][j - 1] + cost);

		}

	}

	// Step 7
        
        max = ST.length()>t.length()?ST.length():t.length();
      //  System.out.println("For word"+ST+"with length"+ST.length()+"and"+t+"with length"+t.length());
        //System.out.println("Max Value:"+max+"Edit Distance Value:"+((double) d[n][m]));
        
	ED = (max - (double) d[n][m])/max;
      //  System.out.println("ED Value"+ED);
        return ED;
    }
}
