/*
 * Lexicon.java
 *
 * Created on February 8, 2005, 10:40 AM
 */

/**
 *
 *          Naushad UzZaman 
 *          Intern: Center for Research on Bangla Language Processing
 *          Senior Student, CSE Dept.
 *          BRAC University
 *          email: naushad@bracuniversity.net
 *                 naushadzaman@gmail.com 
 */

package Speller;

import java.util.*;
import java.io.*;
import javax.swing.*;
import java.net.*;
import java.applet.*;


public class Lexicon {
    
    TreeMap mC;
    String openFileName = " ";
    long count;
    PhoneticEncoding pe;
        /** Creates a new instance of Lexicon */
    public Lexicon() {
        pe = new PhoneticEncoding();
    }
    
        ///method to initialize
	public void initialize() {
		/**
		 * TreeMap:
		 * Red-Black tree based implementation of the SortedMap interface.  
		 * This class guarantees that the map will be in ascending key order.
		 * 
		 *  This implementation provides guaranteed log(n) time cost for the  
		 * containsKey, get, put and remove operations. 
		 */

		///mC: TreeMap for Conventional Dictionary
		mC = new TreeMap();
		inputFile();
		loadWord(openFileName);
	}
        
        public TreeMap getLexiconMap(){
            return mC;
        }
    	/**
	 *LoadWord method only loads word from conventional dictionary, not from 
	 *reverse dictioanary at the same time, when we load from main dictiaonary
	 *we make both(conventioanl and reverse) TreeMap, so we get our desired 
	 *data-structure..
	 */
	//insertword will handle new feature of treemap: that means, the code and the word
	
	public void loadWord(String path) {
		mC.clear();
			//Font f = new Font("Mukti");
                /*
			FileReader fr = new FileReader(path);
                        InputStreamReader isr = new InputStreamReader(fr);
			BufferedReader br = new BufferedReader(isr);
                 */
            //    BufferedReader br;
                 try {
			System.out.println(path);
                     //   URL url = new URL(getCodeBase(), path);
                        //url.openStream()
                        BufferedReader br = new BufferedReader (new InputStreamReader (new FileInputStream(path), "utf-8"));
                    	String s;
			while ((s = br.readLine()) != null) {
				insertWord(s);
			}
			br.close();
		} catch (Exception e) {
			System.out.println(e.getLocalizedMessage());
			System.exit(0);
		}
	}
        
        ///method to open a input file
	public void inputFile() {
		JFileChooser chooser = new JFileChooser();
		int state = chooser.showOpenDialog(null);
		File file = chooser.getSelectedFile();

		if (file != null && state == JFileChooser.APPROVE_OPTION) {
			openFileName = file.getPath();

		} else if (state == JFileChooser.CANCEL_OPTION) {
			JOptionPane.showMessageDialog(null, "Canceled");
		}

            //openFileName = "//tmp//abc.txt";
	}
        
        ///method insertWord, inserts word into the conventional and reverse TreeMap
	///in TreeMap , 1st parameter is key, that is phonetic encoding string;
	///			2nd parameter is value, that is the main string
	public void insertWord(String word) {
                word = word.trim();
		//System.out.println("Inside insert word:"+word.trim());
		mC.put(word.trim(), pe.encoding(word));
		//System.out.println("word:"+word+"phontic encoding:"+PhoneticEncoding.encoding(word));
		count++;
	}

           public boolean ifWord(String s){
            if(mC.containsKey(s)){
                return true;
            }
            else return false;
        }
    /**
	 *StoreWord method stores word into only in conventional dictionary for the 
	 *same reason as loadWord method. 
	 */
	public void storeWord(String path) {
		try {
        Writer pw = new OutputStreamWriter (new FileOutputStream(path),"utf-8");
			//FileWriter fw = new FileWriter(path);
			//BufferedWriter bw = new BufferedWriter(fw);
			//PrintWriter pw = new PrintWriter(bw);

			Set Cset = mC.entrySet();
			Iterator iC = Cset.iterator();
			while (iC.hasNext()) {
				Map.Entry me = (Map.Entry) iC.next();
				//here we write the value only, because that is the main string, not the encoding
				Object element = me.getValue();
				Object elK = me.getKey();
				pw.write(elK.toString()+" "+element.toString()+"\n");
			}
			pw.close();

		} catch (IOException e) {
			System.out.println("Error Writing File!!");
			System.exit(0);
		}
	}

}
