/*
 * PhoneticEncoding.java
 *
 * Created on February 8, 2005, 11:20 AM
 */

/**
 *
 *          Naushad UzZaman 
 *          Intern: Center for Research on Bangla Language Processing
 *          Senior Student, CSE Dept.
 *          BRAC University
 *          email: naushad@bracuniversity.net
 *                 naushadzaman@gmail.com
 */


package Speller;



public class PhoneticEncoding {
		 char encoded[];
		 String kase;
		 int hoshCnt;
		 int extraLen;
		 char strU[];//strU is unicode string
		
	public String encoding(String word)
	{
		char nextChar;
		char prevChar;		
		String dummy;
		int nextHosh;
		int prevHosh;
		
		encoded = new char[word.length()*2];
		kase = "";
		hoshCnt = 0;
		extraLen = 0;
		strU = new char[word.length()*2];//strU is unicode string
		word = word.toLowerCase();
		int i = 0;
		for(int j=0;j<word.length();j++, i++)
		{
			strU[i] = word.charAt(j);
			kase = Dec2Hex((int)strU[i]);
			
			{
					nextHosh = 0;
					prevHosh = 0;	
			}
			
			{
					if(j<word.length()-1)
					{
							nextChar = word.charAt(j+1);
							dummy = Dec2Hex((int)nextChar);
							if(dummy.compareTo("09CD")==0)	//hoshonto	
							{
								nextHosh = 1;
							}
					}
								
					if(j>0)
					{
							prevChar = word.charAt(j-1);
							dummy = Dec2Hex((int)prevChar);
							if(dummy.compareTo("09CD")==0)	//hoshonto	
							{
								prevHosh = 1;	
							}
					}
			}						
				
			
			//System.out.println("Outside loop, kase = "+kase);
			/*
			 * o		?	= 	0985 	-> A
			 * 					0993  	-> O 
			 */
			if(kase.compareTo("0985") == 0 || kase.compareTo("0993")==0)
			{
				
				//System.out.println("Inside encoding, kase = "+ kase);
				encoded[i] = 'o';
			}
			
			/*
			 * 	a	? 	= 	0986	-> AA
					?	=	09BE	-> symbolic AA
			 */
			else if(kase.compareTo("0986")==0 || kase.compareTo("09BE")==0)
			{
				encoded[i] = 'a';
			}
			
			/*
			 * i ? = 0987 -> II	dirgho ee
			 *   ? = 0988 -> I	rosh ee
			 * 	 ? = 09BF -> symbolic I		rosh ee, pashe
				 ? = 09C0 -> symbolic II	dirgho ee, pashe
			 */
			 
			else if(kase.compareTo("0987")== 0 || kase.compareTo("0988")==0 || kase.compareTo("09BF")== 0 || kase.compareTo("09C0")==0) 
			{
				//System.out.println("Inside encoding, kase = "+ kase);
				encoded[i] = 'i';
			}
			
			/*
			 * u ? = 0989 -> 	UU	dirgho u 
				 ? = 098A -> 	U	rosh u 
				 ? = 09C1 -> 	symbolic U	rosh u: niche
				 ? = 09C2 -> 	sumbolic UU	dirgho u: niche
	
			 */
			else if(kase.compareTo("0989")== 0 || kase.compareTo("098A")==0 || kase.compareTo("09C1")== 0 || kase.compareTo("09C2")==0) 
			{
				//System.out.println("Inside encoding, kase = "+ kase);
				encoded[i] = 'u';
			}
			
			/*
			 * 	e	098F	-> E 	:a
			 * 		09CF	-> symbolic E		
			 */
			
			else if(kase.compareTo("098F")== 0 || kase.compareTo("09C7")== 0) 
			{
					//System.out.println("Inside encoding, kase = "+ kase);
					encoded[i] = 'e';
			}
						
			/*
			  oi	?	=	0990	-> AI	:oi
					?	=	09C8	-> sumbolic AI: 	oi; pashe
			 */
			 
			else if(kase.compareTo("0990")==0 || kase.compareTo("09C8")==0) 
			{
				//System.out.println("Inside encoding, kase = "+ kase);
				encoded[i] = 'o';
				i++;
				encoded[i] = 'i';
				extraLen++;
			}
			
			/*
			 *ou 	? = 0994 	: AU	ow
			 *		? = 09CC  	: symbolic AU:	ow; pashe
			 */
			 
			else if(kase.compareTo("0994")==0 || kase.compareTo("09CC")==0) 
			{
				//System.out.println("Inside encoding, kase = "+ kase);
				encoded[i] = 'o';
				i++;
				encoded[i] = 'u';
				extraLen++;
			}
			
			/*
			 * k ? = 0995	: KA	ka 
			 * 	 ? = 0996	: KHA	kha
			 */
			 
			//KA special case 1st then KHA 
			else if(kase.compareTo("0995")==0) 
			{
				
				if(nextHosh==1 && (j+2)<word.length())
				{
					nextChar = word.charAt(j+2);
					dummy = Dec2Hex((int)nextChar);
	 				if(dummy.compareTo("09B7")==0) //SSA
					{
						j += 2;
						if(i==0)
						{
							encoded[i] = 'k'; //KHA
						}
						else if (i > 0)
						{
							encoded[i] = 'k';
							i++;
							encoded[i] = 'k';
							extraLen++;
						}
					}
					else
					{
						encoded[i] = 'k';
					}
				}
				else
				{
					encoded[i] = 'k';
				}
			}
		
			//KHA
			else if(kase.compareTo("0996")==0 ) 
			{
				encoded[i] = 'k';
			}

			/*
			 * g ? = 0997 : GA	ga 
			 * 	 ? = 0998 : GHA	gha
			 */ 
			 
			else if(kase.compareTo("0997")== 0 || kase.compareTo("0998")==0 ) 
			{
				//System.out.println("Inside encoding, kase = "+ kase);
				encoded[i] = 'g';
			}
			 
			/*
			 * ng	? 	0999	NGA	: uwo
			 * 			0982		: onushar	in bangla
			 * 
			 */
	
			 else if(kase.compareTo("0999")==0 || kase.compareTo("0982")==0)
			 {
			 	 encoded[i] = 'n';
			 	 i++;
			 	 encoded[i] = 'g';
			 	 extraLen++;	
			 }
			 
			/*
			 * c ? = 099A	: ca
			 *   ? = 099B 	: cha
			 */ 
			 
			else if(kase.compareTo("099A")== 0 || kase.compareTo("099B")==0 ) 
			{
				//System.out.println("Inside encoding, kase = "+ kase);
				encoded[i] = 'c';
			} 
			
			/*
			 * j ? = 099C 	: JA	borgio ja 
			 *   ? = 099D 	: JHA	jha
			 */
			 
			else if(kase.compareTo("099C")== 0 || kase.compareTo("099D")==0) 
			{
				//System.out.println("Inside encoding, kase = "+ kase);
				encoded[i] = 'j';
			}
			
			/*
			 *  *   ? = 09AF	: YA	ja as fola
			 */
			else if(kase.compareTo("09AF")==0)
			{
				if(j==2 && prevHosh == 1)	//@ the beginning
				{
					encoded[i] = 'e';
                                        nextChar = word.charAt(j+1);
					dummy = Dec2Hex((int)nextChar);
                                        if(dummy.compareTo("09BE")==0)
					{
                                            j++;
					}
				}
				
				else if(prevHosh == 1 && j-2>0)
				{//at middle or end with conjuncts
                                        prevChar = word.charAt(j-3);
					dummy = Dec2Hex((int)prevChar);
					if(dummy.compareTo("09CD")==0) //bo-fola with jukhtakhor
                                        {
                                            //do nothing
                                            i--;
                                        }
                                        else 
                                        {
                                            encoded[i] = encoded[i-1];
                                        }
				}
				
				
				else 
				{
					encoded[i] = 'j';
				}
			}
			
			/*
			 * niwo 099E: NYA
			 */
			 
			else if(kase.compareTo("099E")==0)
			{
				if(prevHosh == 1 && j-2>=0)
				{
					prevChar = word.charAt(j-2);
					dummy = Dec2Hex((int)prevChar);
					if(dummy.compareTo("099A")==0)
					{
						encoded[i] = 'n';
					}
					if(dummy.compareTo("099C")==0)
					{
						if(j==2)
						{
							encoded[i-1] = 'g';
							encoded[i] = 'e';
							
							nextChar = word.charAt(j+1);
							dummy = Dec2Hex((int)nextChar);
							if(dummy.compareTo("09BE")==0)//symbolic AA
							{
								j++;
							}
					
						}
						
						else if(j>2)
						{
							encoded[i-1] = 'g';
							encoded[i] = 'g';
						}
					}
				}
				else if(nextHosh == 1 && j+2<word.length())
				{
					nextChar = word.charAt(j+2);
					dummy = Dec2Hex((int)nextChar);
					//NYA + CA/CHA/JA/JHA
					if(dummy.compareTo("099A")==0 || dummy.compareTo("099B")==0 || dummy.compareTo("099C")==0 || dummy.compareTo("099D")==0)
					{
						encoded[i] = 'n';	
					}
					//NYA + A/I
					else if(dummy.compareTo("0985")==0 || dummy.compareTo("0987")==0)
					{
						//no sound
						i--;
					}
					else
					{
						encoded[i] ='n';
						i++;
						encoded[i] = 'g';
						extraLen++;
					}
				}
				
				else
				{
					encoded[i] ='n';
					i++;
					encoded[i] = 'g';
					extraLen++;			
				}
			}
			
			/*
			 * t ? = 099F : TTA	ta 
			 * 	 ? = 09A0 : TTHA	tha
			 */
			 
			else if(kase.compareTo("099F")== 0 || kase.compareTo("09A0")==0) 
			{
				//System.out.println("Inside encoding, kase = "+ kase);
				encoded[i] = 'T';
			}
			
			/*
			 * d ? = 09A1 	: DDA	da
			 *   ? = 09A2 	: DDHA	dha
			 */ 
			 
			else if(kase.compareTo("09A1")== 0 || kase.compareTo("09A2")==0) 
			{
				//System.out.println("Inside encoding, kase = "+ kase);
				encoded[i] = 'D';
			} 
			

			/*
			 * 				ri	098B	VOCALIC R	: ri
			 * 					09C3	symbolic VOCALIC R : niche ri
			 */
			else if(kase.compareTo("098B")==0 || kase.compareTo("09C3")==0)
			{
				encoded[i] = 'r';
				i++;
				encoded[i] = 'i';
				extraLen++;
			}
			
			/*
						 * r		? 	=	09B0	: RA	bo shunno ro
						 *			? 	=	09DC	: RRA	do shunno ro
						 *			? 	=	09DD	: DDHA	dho shunno Ro
			 */ 
			
			
			else if(kase.compareTo("09B0")== 0 || kase.compareTo("09DC")==0 || kase.compareTo("09DD")==0) 
			{
						//System.out.println("Inside encoding, kase = "+ kase);
						encoded[i] = 'r';
			}
			
			/*
			 * n ? = 09A8 	NA	: donton no  
			 *   ? = 09A3   NNA	: murdhon no
			 */
			 
			else if(kase.compareTo("09A8")== 0 || kase.compareTo("09A3")==0) 
			{
				//System.out.println("Inside encoding, kase = "+ kase);
				encoded[i] = 'n';
			} 
			
			/*
			 * t ? = 09A4 : TA	ta 
			 * 	 ? = 09A5 : THA	tha
			 */
			 
			else if(kase.compareTo("09A4")== 0 || kase.compareTo("09A5")==0) 
			{
				//System.out.println("Inside encoding, kase = "+ kase);
				encoded[i] = 't';
			} 
			 
			/*
			 * d ? = 09A6  : DA		da -> dhaka
			 *   ? = 09A7  : DHA	dha -> dhaormo
			 */ 
			else if(kase.compareTo("09A6")== 0 || kase.compareTo("09A7")==0) 
			{
				//System.out.println("Inside encoding, kase = "+ kase);
				encoded[i] = 'd';
			}
			 
			/*
			 * p		? 	=	09AA : 	po	 : pola
			 *			?	=	09AB :  fo	 : fol
			 */
			
			else if(kase.compareTo("09AA")== 0 || kase.compareTo("09AB")==0) 
			{
				//System.out.println("Inside encoding, kase = "+ kase);
				encoded[i] = 'p';
			} 
			
			/*
			 * b		?	=	09AD : bho 	: bhola
			 */
			else if(kase.compareTo("09AD")==0) 
			{
							//System.out.println("Inside encoding, kase = "+ kase);
							encoded[i] = 'b';
			} 
			
			/* 
			* b		? 	=	09AC : bo	: bolo
			*/
			 
			else if(kase.compareTo("09AC")== 0) 
			{
					if(prevHosh==0 && nextHosh==0)
						encoded[i] = 'b';
					//as fola	
					else if (prevHosh==1) 
					{
						if(j==2)//@the beginning
						{
							//do nothing
							i--;
						}
						else if(j>2)
						{
							prevChar = word.charAt(j-3);
							dummy = Dec2Hex((int)prevChar);
							if(dummy.compareTo("09CD")==0) //bo-fola with jukhtakhor
							{
								//do nothing
								i--;
							}	
							else
							{
							
								prevChar = word.charAt(j-2);
								dummy = Dec2Hex((int)prevChar);
								//BA / MA / GA 
						    	if (dummy.compareTo("09AC")==0 || dummy.compareTo("09AE")==0 || dummy.compareTo("0997")==0)					
								{
									encoded[i] = 'b';
								}
								//d
								else if(dummy.compareTo("09A6")==0)//udbeg
								{
								    //u
									prevChar = word.charAt(j-3);
									dummy = Dec2Hex((int)prevChar);
									if(dummy.compareTo("0989")==0)
									{
										encoded[i] = 'b';
									}
								}
							
								else
								{
									encoded[i] = encoded[i-1];
								}
							}
						}
					}					
					else
					{
						encoded[i] = 'b';
					}
			} 
			  
			/*
			 * m		? 	=	09AE: mo
			 */ 
			
			else if(kase.compareTo("09AE")== 0) 
			{
				if(prevHosh==0 && nextHosh==0)
					encoded[i] = 'm';
					//as fola	
				else if (prevHosh==1) 
				{
					if(j==2)//@the beginning
					{
						//do nothing
						i--;
					}
					
					else if(j>2)
					{
						prevChar = word.charAt(j-3);
						dummy = Dec2Hex((int)prevChar);
						if(dummy.compareTo("09CD")==0) //bo-fola with jukhtakhor
						{
							//do nothing
							i--;
						}	
						
						else
						{
							prevChar = word.charAt(j-2);
							dummy = Dec2Hex((int)prevChar);
							//KA / GA / NGA / TTA / NA / NNA / MA / LA / S / SSA / SHA
							if (dummy.compareTo("0995")==0 || dummy.compareTo("0997")==0 || dummy.compareTo("0999")==0 || dummy.compareTo("099F")==0 || dummy.compareTo("09A3")==0 || dummy.compareTo("09A8")==0 || dummy.compareTo("09AE")==0 || dummy.compareTo("09B2")==0 || dummy.compareTo("09B6")==0 || dummy.compareTo("09B7")==0 || dummy.compareTo("09B8")==0)					
							{
								encoded[i] = 'm';
							}
												
							else
							{
								encoded[i] = encoded[i-1];
							}
						}
					}
				}					
				else
				{
					encoded[i] = 'm';
				}			
			} 
			 
			/*
			 *	y	? 	09DF:  YYA	: ontostho yeo	boyosh
			 */
			 
			else if(kase.compareTo("09DF")==0)
			{
						encoded[i] = 'y';
			}
			 

			/*
			 * l		? 	=	09B2: LA	lo
			 */ 
			else if(kase.compareTo("09B2")== 0) 
			{
						//System.out.println("Inside encoding, kase = "+ kase);
						encoded[i] = 'l';
			}
			
			/*
			 * s		? 	=	09B8: SA	dontonno sho
			 *			? 	=	09B7: SSA	murdhonno sho
			 * 			?	=	09B6: SHA	tal bosh sho
			 */ 
			
			else if(kase.compareTo("09B8")== 0 || kase.compareTo("09B7")==0 || kase.compareTo("09B6")==0) 
			{
						//System.out.println("Inside encoding, kase = "+ kase);
						encoded[i] = 's';
			}
			 
			/*
			 * h		? 	=	09B9: ho
			 */
			 //add onushor later
			else if(kase.compareTo("09B9")== 0) 
			{
	
				if(nextHosh == 0 && prevHosh == 0)
					encoded[i] = 'h';
				else if(nextHosh == 1)
				{
					nextChar = word.charAt(j+2);
					dummy = Dec2Hex((int)nextChar);
					if(dummy.compareTo("098B")==0 || dummy.compareTo("09B0")==0)//VOCALIC R : ri | R as fola
					{
						i--;
					}
					else if (dummy.compareTo("09AE")==0) // M: mo
					{
						encoded[i] = 'm';
						i++;
						j += 2;
						encoded[i] = 'm';
						//no need to increase extraLen..
					}
					else if(dummy.compareTo("09AF")==0 && j>2)//YA as fola
					{
						encoded[i] = 'j';
						i++;
						j+=2;
						encoded[i] = 'j';
						//no need to increase extraLen
					}
					else if(dummy.compareTo("09B2")==0)//LA
					{
						if(j==0)
						{
							encoded[i] = 'l';
						}
						else
						{
							encoded[i] = 'l';
							i++;
							encoded[i] = 'l';	
						}
						j += 2;
						
					}
					
					else if(dummy.compareTo("09A3")==0 || dummy.compareTo("09A8")==0)
					{
						encoded[i] = 'n';
						i++;
						encoded[i] = 'n';
					}
					else if(dummy.compareTo("09AC")==0) //BA
					{
						encoded[i] = 'h';
						i++;
						j += 2;
						encoded[i] = 'b';
					}
					else
					{
						encoded[i] = 'h';							
					}
					
				}
			}
			
			/*
			 * 	0983	bishorgo
			 */
			else if(kase.compareTo("0983")==0)
			{
				if(j==word.length()-1)
				{
					if(j==1 || j == 2)
					{
						encoded[i] = 'h';	
					}
							
					else
					{
						i--;		
					}
				}
			}
			
			/*
			 *no sound		?	=	09CD	(hoshonto)
			 * 					0981	chondrobindu
			 * 					09CB	symbolic O
			 */ 
			else if(kase.compareTo("09CD")== 0 || kase.compareTo("0981")==0 || kase.compareTo("09CB")==0) 
			{
						//System.out.println("Inside encoding, kase = "+ kase);
						//encoded[i] = 'v';
						hoshCnt++;
						i--;
			}
			 
			/*
			 * to trace rest alphabets 
			 */
			else if((word.charAt(j)>='a' && word.charAt(j) <='z') || (word.charAt(j)>='A' && word.charAt(j)<='Z'))
			{
                            char chE, ch2 = '9';
                            chE = word.charAt(j);
                            
                            if(j+1<word.length())
                                ch2 = word.charAt(j+1);
                            
                            if(chE=='q' || chE == 'k')
                            {
                                encoded[i] = chE;
                                if(ch2=='h')
                                    j+=1;
                            }
                            
                            else if(chE=='g')
                            {
                                encoded[i] = chE;
                                if(ch2=='h')
                                    j+=1;
                            }
                            
                            else if(chE=='c')
                            {
                                encoded[i] = chE;
                                if(ch2=='h')
                                    j+=1;
                            }
                            
                            else if(chE=='j')
                            {
                                encoded[i] = chE;
                                if(ch2=='h')
                                    j+=1;
                            }
                            
                            else if(chE=='t')
                            {
                                encoded[i] = chE;
                                if(ch2=='h')
                                    j+=1;
                            }
                            
                            else if(chE=='d')
                            {
                                encoded[i] = chE;
                                if(ch2=='h')
                                    j+=1;
                            }
                            
                            else if(chE=='p' || chE=='f')
                            {
                                encoded[i] = chE;
                                if(ch2=='h')
                                    j+=1;
                            }
                            
                            else if(chE=='b' || chE=='v')
                            {
                                encoded[i] = chE;
                                if(ch2=='h')
                                    j+=1;
                            }

                            else if(chE=='s')
                            {
                                encoded[i] = chE;
                                if(ch2=='h')
                                    j+=1;
                            }
                            
                            else if(chE=='n' && ch2=='g')
                            {
                                encoded[i] = chE;
                                i++;
                                j+=1;
                                encoded[i] = ch2;
                                //if(ch2=='g')
                                    
                            }
                            
                            else if(chE=='n' || chE=='m' || chE=='r' 
                            || chE=='l' || chE=='h')
                            {
                                encoded[i] = chE;
                            }
                            
                            else if(chE=='w')
                            {
                                encoded[i] = 'o';
                                i++;
                                encoded[i] = 'a';
                            }
                            
                            else if(chE=='y')
                            {
                                encoded[i] = chE;
                            }
                            
                            else if(chE == 'x')
                            {
                                if(j==0)
                                    encoded[i] = 'j';
                                else {
                                    encoded[i] = 'k';
                                    i++;
                                    encoded[i] = 's';
                                }
                            }
                            
                            else if(chE == 'e' && ch2 == 'e'){
                                encoded[i] = 'i';
                                j++;
                            }
                            
                            else if(chE=='o' && ch2=='i'){
                                encoded[i] = 'o';
                                i++; j++;
                                encoded[i] = 'i';
                            }
                            
                            else if(chE=='o' && ch2=='u'){
                                encoded[i] = 'o';
                                i++; j++;
                                encoded[i] = 'u';
                            }
                            
                            else if(chE=='o' && j>0){
                                i--;
                            }
                                
                            else{
                                encoded[i] = chE;
                            }
			 //encoded[i] = chE;
                        }
                        
                        else{
			 	encoded[i] = 'x';
			}
			
			if(j>0)
			{
				prevChar = word.charAt(j-1);
				dummy = Dec2Hex((int)prevChar);
				if(dummy.compareTo("0983")==0)
				{
					i++;
					encoded[i] = encoded[i-1];
					extraLen++;
				}
			}
		}
		//System.out.println("hoshCnt = "+hoshCnt);
		
		String finalDummy = new String(encoded);
		//String encodedStr = finalDummy.substring(0, word.length()-hoshCnt+extraLen);
                String encodedStr = finalDummy.substring(0, i);
		//System.out.println("Encoded String: "+encodedStr+" with len: "+encodedStr.length());
		return encodedStr;
	}
		
	public static void printUnicode(String word)
	{
		char strU[] = new char[word.length()];
		for(int i=0;i<word.length();i++)
		{
			strU[i] = word.charAt(i);
			//System.out.println(strU[i]+" "+(int)strU[i]+" "+Dec2Hex((int)strU[i]));
		}
	}
	
	
	public static String Dec2Hex(int valDec) {
		int base = 16;
		int i = 0;
		char tmp[] = new char[4];
		char ch;
		int rem;
		while (valDec != 0) {
			rem = valDec % base;
			if (rem <= 9) {
				ch = '0';
				while (rem-- != -1)
					tmp[i] = ch++;
				ch = '0';
			} else {
				ch = 'A';
				rem -= 10;
				while (rem-- != -1)
					tmp[i] = ch++;
				ch = '0';
			}
			i++;
			valDec /= base;
		}

		if (i < 4) {
			while (i != 4) {
				tmp[i++] = '0';
			}
		}

		char tmp2[] = new char[4];
		for (i = 0; i < 4; i++) {
			tmp2[i] = tmp[4 - 1 - i];
		}
		String hexVal = new String(tmp2);

		return hexVal;
	}

}
