/*
 * SuggestionBox.java
 *
 * Created on March 10, 2005, 10:35 AM
 */

/**
 *
 *          Naushad UzZaman 
 *          Intern: Center for Research on Bangla Language Processing
 *          Senior Student, CSE Dept.
 *          BRAC University
 *          email: naushad@bracuniversity.net
 *                 naushadzaman@gmail.com
 */


package Speller;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.util.*;

public class SuggestionBox extends JPanel implements ActionListener, ListSelectionListener{
    int r = 205;
    int g = 221;
    int b = 233;
    Color mycolor = new Color(r, g, b);
  /** The Ignore button click action command*/
  Font f = new Font("Amoraboti-Unicode", 0, 15);
  
  public final String IGNORE_CMD = "\u098F\u09AE\u09A8\u09BF \u09A5\u09BE\u0995";
  /** The Ignore All button click action command*/
  public final String IGNOREALL_CMD = "\u09B8\u09AC \u098F\u09AE\u09A8\u09BF \u09A5\u09BE\u0995";
  /** The Add button click action command*/
  public final String ADD_CMD = "\u09AF\u09C1\u0995\u09CD\u09A4 \u0995\u09B0";
  /** The Replace button click action command*/
  public final String REPLACE_CMD = "\u09AC\u09A6\u09B2\u09C7 \u09A6\u09BE\u0993";
  /** The Replace All button click action command*/
  public final String REPLACEALL_CMD = "\u09B8\u09AC \u09AC\u09A6\u09B2\u09C7 \u09A6\u09BE\u0993";
  /** The Cancel button click action command*/
  public final String CANCEL_CMD = "\u0995\u09BF\u099B\u09C1\u0987 \u09A8\u09DF";
  /** The resource for the Suggestions label*/
  public final String SUGGESTIONS_RES = "\u0986\u09AA\u09A8\u09BF \u0995\u09BF \u09AD\u09BE\u09AC\u099B\u09C7\u09A8";
  public final String INVALIDWORD_RES = "\u09AD\u09C1\u09B2 \u09AC\u09BE\u09A8\u09BE\u09A8";
  /** Add word confirm*/
  public final String ADDWORD_1 = "ADDWORD_1";
  public final String ADDWORD_2 = "ADDWORD_2";
  public final String ADDWORD_3 = "ADDWORD_3";
  
  public JLabel wrongWordLabel;

  /* Accessible GUI Components */
  public JList suggestList;
  public JTextField checkText;
  ParseParagraph par;
  ProcessParagraph por;
  int noOfWord = 100;
  String [] words;// = new String[noOfWord];
  TreeMap [] sugList;// = new TreeMap [noOfWord];
  String [] wrongWords;// = new String[noOfWord];
 
  JPanel jPanel1 = new JPanel();
  JButton ignoreBtn = new JButton(IGNORE_CMD);    
  JButton ignoreAllBtn = new JButton(IGNOREALL_CMD);    
  JButton addBtn = new JButton(ADD_CMD);    
  JButton changeBtn = new JButton(REPLACE_CMD);    
  JButton changeAllBtn = new JButton(REPLACEALL_CMD);    
  JButton cancelBtn = new JButton(CANCEL_CMD);    
  JPanel jPanel2 = new JPanel();
  Font flbl = new Font("Amoraboti-Unicode", 1, 16);
  JLabel lbl1 = new JLabel(INVALIDWORD_RES);
  JLabel lbl2 = new JLabel(SUGGESTIONS_RES);
  int currentWord;
  JFrame jfrm;
  /** Panel constructor */
  public SuggestionBox(String [] wrd, String [] wrongwrd, TreeMap [] sug, JFrame frm) {
      jfrm = frm;
      words = new String[wrd.length];
      PhoneticEncoding p = new PhoneticEncoding();
      for(int i=0;i<wrd.length;i++)
      {
          words[i] = wrd[i];
          System.out.println(words[i]+"|with encoding:"+p.encoding(words[i]));
      }
      wrongWords = new String[wrongwrd.length];
      for(int j=0;j<wrongwrd.length;j++)
      {
          wrongWords[j] = wrongwrd[j];
      }
      sugList = new TreeMap[sug.length];
      for(int k=0;k<sug.length;k++)
      {
          sugList[k] = sug[k];
      }
      currentWord = 0;
      initialiseGUI();
      printWords();   
      
  }

  public void noError(){
      JOptionPane jpe = new JOptionPane();
      jpe.setFont(f);
      jpe.showMessageDialog(null, "\u0995\u09CB\u09A8 \u09AC\u09BE\u09A8\u09BE\u09A8 \u09AD\u09C1\u09B2 \u09A8\u09C7\u0987");
  }

  public void checkComplete(){
      JOptionPane jpc = new JOptionPane();
      jpc.setFont(f);
      jpc.showMessageDialog(null, "\u09AD\u09C1\u09B2 \u09AC\u09BE\u09A8\u09BE\u09A8 \u0996\u09CB\u09FA\u099C\u09BE \u09B6\u09C7\u09B7");
  }
    
  public void printWords(){
      PhoneticEncoding pe = new PhoneticEncoding();
      for(int i=0;i<wrongWords.length;i++){
          System.out.println(pe.encoding(wrongWords[i]));
      }
      System.out.println(wrongWords.length+":Misspelled words");
      System.out.println(sugList.length+":Suggestions..");
  }
  public void generateSuggestionBox(){
      //System.out.println("from Box:"+str);
      if(currentWord>=wrongWords.length){
          jfrm.dispose();          
          checkComplete();
          System.out.println("i got it..");
            return;
      }
      
        suggestList.removeAll();
        String curWord = wrongWords[currentWord];
        TreeMap curSug = sugList[currentWord];
        String[] data = {"", "", "", "", "", "", "", "", "", "", "", ""};
        checkText.setFont(f);
        checkText.setText(curWord);
        int k = 0;
        try{
            Set Cs = curSug.entrySet();
            Iterator iC = Cs.iterator();
            while (iC.hasNext()) {
                Map.Entry me = (Map.Entry) iC.next();
                Object elK = me.getKey();
                Object element = me.getValue();
                //System.out.println("main: Suggestion for"+curWord+":"+element.toString());
                        //here key is the score and value is the word
                data[k] = element.toString();
                k++;
            }
                
        }
        catch(Exception e){
            System.out.println("Failed in the TreeMap generateSuggestionBox");
        }
        suggestList.setFont(f);
        suggestList.setListData(data);
        //suggestList.
        currentWord++;
      
  }
                
  /** Creates the buttons on the left hand side of the panel*/
  public JPanel makeEastPanel() {
    BoxLayout layout = new BoxLayout(jPanel1, BoxLayout.Y_AXIS);
    jPanel1.setLayout(layout);

    //IGNORE button 
    ignoreBtn.setBackground(mycolor);
    ignoreBtn.setMaximumSize(new Dimension(Short.MAX_VALUE, Short.MAX_VALUE));
    jPanel1.add(ignoreBtn);
    ignoreBtn.addActionListener(this);
    ignoreBtn.setFont(f);
    
    //IGNOREALL button
    ignoreAllBtn.setBackground(mycolor);
    ignoreAllBtn.setMaximumSize(new Dimension(Short.MAX_VALUE, Short.MAX_VALUE));
    jPanel1.add(ignoreAllBtn);
    ignoreAllBtn.addActionListener(this);
    ignoreAllBtn.setFont(f);
    
    //ADD button
    addBtn.setBackground(mycolor);
    addBtn.setMaximumSize(new Dimension(Short.MAX_VALUE, Short.MAX_VALUE));
    jPanel1.add(addBtn);
    addBtn.addActionListener(this);
    addBtn.setFont(f);
    
    //REPLACE button
    changeBtn.setBackground(mycolor);
    changeBtn.setMaximumSize(new Dimension(Short.MAX_VALUE, Short.MAX_VALUE));
    jPanel1.add(changeBtn);
    changeBtn.addActionListener(this);
    changeBtn.setFont(f);
    
    //REPLACEALL button
    changeAllBtn.setBackground(mycolor);
    changeAllBtn.setMaximumSize(new Dimension(Short.MAX_VALUE, Short.MAX_VALUE));
    jPanel1.add(changeAllBtn);
    changeAllBtn.addActionListener(this);
    changeAllBtn.setFont(f);

    //CANCEL button
    cancelBtn.setBackground(mycolor);
    cancelBtn.setMaximumSize(new Dimension(Short.MAX_VALUE, Short.MAX_VALUE));
    jPanel1.add(cancelBtn);
    cancelBtn.addActionListener(this);
    cancelBtn.setFont(f);
    
    return jPanel1;
  }

        
  public JPanel makeCentrePanel() {
    jPanel2.setLayout(new BoxLayout(jPanel2, BoxLayout.Y_AXIS));
    JPanel jPanel3 = new JPanel();
    //Label: Invalid word
    lbl1.setFont(flbl);
    lbl2.setFont(flbl);
      
    lbl1.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
    wrongWordLabel = new JLabel("");
    wrongWordLabel.setForeground(Color.red); //Changed Color.RED to Color.red for 1.3 compatibility.
    jPanel3.add(lbl1);
    jPanel3.add(wrongWordLabel);
    jPanel2.add(jPanel3);
    checkText = new JTextField();
    checkText.setEditable(false);
    checkText.setBackground(mycolor);
    //checkText.setText("Test");
    jPanel2.add(checkText);
    
    //Label: Did you mean
    lbl2.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
    jPanel2.add(lbl2);
    suggestList = new JList();
    suggestList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    suggestList.addListSelectionListener(this);
    generateSuggestionBox();
    jPanel2.add(new JScrollPane(suggestList));
    return jPanel2;
  }

  /** Called by the constructor to initialise the GUI*/
  public void initialiseGUI() {
    setLayout(new BorderLayout());
    this.add(makeEastPanel(), BorderLayout.EAST);
    this.add(makeCentrePanel(), BorderLayout.CENTER);
  }
  
  public void valueChanged(ListSelectionEvent e){
      String valStr = (suggestList.getSelectedValue()).toString();
      //System.out.println("suggest:"+valStr);
      checkText.setText(valStr);
  }
  
    
  public void actionPerformed(ActionEvent e) {
        String actStr = e.getActionCommand();
        if(actStr == IGNORE_CMD){
            System.out.println("Ignore new");
            generateSuggestionBox();
            
        }
        if(actStr == IGNOREALL_CMD){
            System.out.println("IgnoreAll new"); 
            jfrm.dispose();
        }
        if(actStr == ADD_CMD){
        System.out.println("Add new"); 
        }
        if(actStr == REPLACE_CMD){
            System.out.println("Replace new"); 
        }
        if(actStr == REPLACEALL_CMD){
            System.out.println("ReplaceAll new"); 
        }
        if(actStr == CANCEL_CMD){
            System.out.println("Cancel new"); 
            jfrm.dispose();
        }
  }

}


